//---------------------------------------------------------------------------
// convmain.cpp : rtkconv main (rtklib receiver log to rinex converter)
//
//			Copyright (C) 2007 by T.TAKASU, All rights reserved.
//
// version : $Revision: 1.1 $ $Date: 2008/07/17 22:16:10 $
// history : 2008/07/14  1.0 new
//---------------------------------------------------------------------------
#include <vcl.h>
#include <vcl\inifiles.hpp>
#pragma hdrstop
#include "convmain.h"
#include "convopt.h"
#include "viewer.h"
#include "rtklib.h"
#include "ublox.h"
#include "novatel.h"
#include "crescent.h"
#include "garmin.h"
#include "ss2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainWindow *MainWindow;

#define PRGNAME		"RTKCONV ver.2.1.0"

static int abortf=0;
//---------------------------------------------------------------------------
extern "C" {
extern int showmsg(char *format,...)
{
	static int i=0;
    va_list arg;
    char buff[1024];
    va_start(arg,format); vsprintf(buff,format,arg); va_end(arg);
	MainWindow->Message->Caption=buff;
	if (++i%100==0) Application->ProcessMessages();
	return abortf;
}
}
//---------------------------------------------------------------------------
__fastcall TMainWindow::TMainWindow(TComponent* Owner)
	: TForm(Owner)
{
	DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::FormShow(TObject *Sender)
{
	TIniFile *ini=new TIniFile("rtkconv.ini");
	TimeStartF->Checked=ini->ReadInteger("set","timestartf",0);
	TimeEndF->Checked  =ini->ReadInteger("set","timeendf",0);
	TimeIntF->Checked  =ini->ReadInteger("set","timeintf",0);
	TimeY1->Text       =ini->ReadString ("set","timey1","2000/01/01");
	TimeH1->Text       =ini->ReadString ("set","timeh1","00:00:00");
	TimeY2->Text       =ini->ReadString ("set","timey2","2000/01/01");
	TimeH2->Text       =ini->ReadString ("set","timeh2","00:00:00");
	TimeInt->Text      =ini->ReadString ("set","timeint","1");
	InFile->Text       =ini->ReadString ("set","infile","");
	OutFile1->Text     =ini->ReadString ("set","outfile1","");
	OutFile2->Text     =ini->ReadString ("set","outfile2","");
	OutFile3->Text     =ini->ReadString ("set","outfile3","");
	OutFileEna1->Checked=ini->ReadInteger("set","outfileena1",1);
	OutFileEna2->Checked=ini->ReadInteger("set","outfileena2",1);
	OutFileEna3->Checked=ini->ReadInteger("set","outfileena3",1);
	Format->ItemIndex  =ini->ReadInteger("set","format",0);
	
	RunBy              =ini->ReadString ("opt","runby","");
	Marker             =ini->ReadString ("opt","marker","");
	Name[0]            =ini->ReadString ("opt","name0","");
	Name[1]            =ini->ReadString ("opt","name1","");
	Rec[0]             =ini->ReadString ("opt","rec0","");
	Rec[1]             =ini->ReadString ("opt","rec1","");
	Rec[2]             =ini->ReadString ("opt","rec2","");
	Ant[0]             =ini->ReadString ("opt","ant0","");
	Ant[1]             =ini->ReadString ("opt","ant1","");
	Ant[2]             =ini->ReadString ("opt","ant2","");
	AppPos[0]          =ini->ReadFloat  ("opt","apppos0",0.0);
	AppPos[1]          =ini->ReadFloat  ("opt","apppos1",0.0);
	AppPos[2]          =ini->ReadFloat  ("opt","apppos2",0.0);
	AntDel[0]          =ini->ReadFloat  ("opt","antdel0",0.0);
	AntDel[1]          =ini->ReadFloat  ("opt","antdel1",0.0);
	AntDel[2]          =ini->ReadFloat  ("opt","antdel2",0.0);
	Comment[0]         =ini->ReadString ("opt","comment0","");
	Comment[1]         =ini->ReadString ("opt","comment1","");
	Option[0]          =ini->ReadInteger("opt","option0",0);
	Option[1]          =ini->ReadInteger("opt","option1",0);
	Option[2]          =ini->ReadInteger("opt","option2",0);
    
    TTextViewer::Color1=(TColor)ini->ReadInteger("viewer","color1",(int)clBlack);
    TTextViewer::Color2=(TColor)ini->ReadInteger("viewer","color2",(int)clWhite);
    TTextViewer::FontD=new TFont;
    TTextViewer::FontD->Name=ini->ReadString("viewer","fontname","Courier New");
    TTextViewer::FontD->Size=ini->ReadInteger("viewer","fontsize",9);
   	delete ini;
	UpdateEnable();
	Caption=PRGNAME;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::FormClose(TObject *Sender, TCloseAction &Action)
{
	TIniFile *ini=new TIniFile("rtkconv.ini");
	ini->WriteInteger("set","timestartf",TimeStartF->Checked);
	ini->WriteInteger("set","timeendf",TimeEndF->Checked);
	ini->WriteInteger("set","timeintf",TimeIntF->Checked);
	ini->WriteString ("set","timey1",TimeY1->Text);
	ini->WriteString ("set","timeh1",TimeH1->Text);
	ini->WriteString ("set","timey2",TimeY2->Text);
	ini->WriteString ("set","timeh2",TimeH2->Text);
	ini->WriteString ("set","timeint",TimeInt->Text);
	ini->WriteString ("set","infile",InFile->Text);
	ini->WriteString ("set","outfile1",OutFile1->Text);
	ini->WriteString ("set","outfile2",OutFile2->Text);
	ini->WriteString ("set","outfile3",OutFile3->Text);
	ini->WriteInteger("set","outfileena1",OutFileEna1->Checked);
	ini->WriteInteger("set","outfileena2",OutFileEna2->Checked);
	ini->WriteInteger("set","outfileena3",OutFileEna3->Checked);
	ini->WriteInteger("set","format",Format->ItemIndex);
	
	ini->WriteString ("opt","runby",RunBy);
	ini->WriteString ("opt","marker",Marker);
	ini->WriteString ("opt","name0",Name[0]);
	ini->WriteString ("opt","name1",Name[1]);
	ini->WriteString ("opt","rec0",Rec[0]);
	ini->WriteString ("opt","rec1",Rec[1]);
	ini->WriteString ("opt","rec2",Rec[2]);
	ini->WriteString ("opt","ant0",Ant[0]);
	ini->WriteString ("opt","ant1",Ant[1]);
	ini->WriteString ("opt","ant2",Ant[2]);
	ini->WriteFloat  ("opt","apppos0",AppPos[0]);
	ini->WriteFloat  ("opt","apppos1",AppPos[1]);
	ini->WriteFloat  ("opt","apppos2",AppPos[2]);
	ini->WriteFloat  ("opt","antdel0",AntDel[0]);
	ini->WriteFloat  ("opt","antdel1",AntDel[1]);
	ini->WriteFloat  ("opt","antdel2",AntDel[2]);
	ini->WriteString ("opt","comment0",Comment[0]);
	ini->WriteString ("opt","comment1",Comment[1]);
	ini->WriteInteger("opt","option0",Option[0]);
	ini->WriteInteger("opt","option1",Option[1]);
	ini->WriteInteger("opt","option2",Option[2]);
    
    ini->WriteInteger("viewer","color1",(int)TTextViewer::Color1);
    ini->WriteInteger("viewer","color2",(int)TTextViewer::Color2);
    ini->WriteString ("viewer","fontname",TTextViewer::FontD->Name);
    ini->WriteInteger("viewer","fontsize",TTextViewer::FontD->Size);
   	delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::ConvertFile(void)
{
	rnxopt_t rnxopt={0};
	gtime_t ts={0},te={0};
	double tint=0.0,eps[]={2000,1,1,0,0,0},epe[]={2000,1,1,0,0,0};
	int type,opt=0;
	char file[1024],ofile[1024]="",nfile[1024]="",sfile[1024]="";
	char msg[256],*p,*rcvtype;
	
	if (BtnConvert->Caption=="Abort") {
		abortf=1;
		return;
	}
	if (TimeStartF->Checked) {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",eps,eps+1,eps+2);
		sscanf(TimeH1->Text.c_str(),"%lf:%lf:%lf",eps+3,eps+4,eps+5);
		ts=epoch2time(eps);
	}
	if (TimeEndF->Checked) {
		sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",epe,epe+1,epe+2);
		sscanf(TimeH2->Text.c_str(),"%lf:%lf:%lf",epe+3,epe+4,epe+5);
		te=epoch2time(epe);
	}
	if (TimeIntF->Checked) {
		sscanf(TimeInt->Text.c_str(),"%lf",&tint);
	}
	strcpy(file,InFile->Text.c_str());
	if (!(p=strrchr(file,'.'))) p=file;
	if ((Format->ItemIndex==0&&!strcmp(p,".gps"))||Format->ItemIndex==1) {
		type=RCVLOG_NOV; rcvtype="OEMV/4";
	}
	else if ((Format->ItemIndex==0&&!strcmp(p,".ubx"))||Format->ItemIndex==2) {
		if (Option[0]) opt|=OPTUBX5;
		type=RCVLOG_UBX; rcvtype="u-blox";
	}
	else if ((Format->ItemIndex==0&&!strcmp(p,".log"))||Format->ItemIndex==3) {
		type=RCVLOG_SS2; rcvtype="Superstar II";
	}
	else if ((Format->ItemIndex==0&&!strcmp(p,".bin"))||Format->ItemIndex==4) {
		type=RCVLOG_CRES; rcvtype="Crescent";
	}
	else if ((Format->ItemIndex==0&&!strcmp(p,".gam"))||Format->ItemIndex==5) {
		type=RCVLOG_GARM; rcvtype="Garmin";
	}
	else if ((Format->ItemIndex==0&&!strcmp(p,".sir"))||Format->ItemIndex==6) {
		type=RCVLOG_SIRF; rcvtype="SiRF II";
	}
	else {
		showmsg("input file error : %s\n",file);
		return;
	}
	if (OutFileEna1->Checked) strcpy(ofile,OutFile1->Text.c_str());
	if (OutFileEna2->Checked) strcpy(nfile,OutFile2->Text.c_str());
	if (OutFileEna3->Checked) strcpy(sfile,OutFile3->Text.c_str());
	strcpy(rnxopt.prog,PRGNAME);
	strncpy(rnxopt.runby,RunBy.c_str(),31);
	strncpy(rnxopt.marker,Marker.c_str(),63);
	for (int i=0;i<2;i++) strncpy(rnxopt.name[i],Name[i].c_str(),31);
	for (int i=0;i<3;i++) strncpy(rnxopt.rec[i],Rec[i].c_str(),31);
	for (int i=0;i<3;i++) strncpy(rnxopt.ant[i],Ant[i].c_str(),31);
	for (int i=0;i<3;i++) rnxopt.apppos[i]=AppPos[i];
	for (int i=0;i<3;i++) rnxopt.antdel[i]=AntDel[i];
	sprintf(rnxopt.comment[0],"log file: %-53.53s",file);
	sprintf(rnxopt.comment[1],"rcv type: %s",rcvtype);
	for (int i=0;i<2;i++) strncpy(rnxopt.comment[i+2],Comment[i].c_str(),63);
	abortf=0;
	BtnConvert->Caption="Abort";
	Panel1->Enabled=false;
	Panel2->Enabled=false;
	BtnOptions->Enabled=false;
	BtnExit->Enabled=false;
	BtnArrow->Enabled=true;
    Message->Caption="";
	if (!convlog(file,type,ofile,nfile,sfile,ts,te,tint,&rnxopt,opt)) {
		showmsg("convertion error : %s",file);
	}
	BtnConvert->Caption="&Convert";
	Panel1->Enabled=true;
	Panel2->Enabled=true;
	BtnOptions->Enabled=true;
	BtnExit->Enabled=true;
	BtnArrow->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnConvertClick(TObject *Sender)
{
	ConvertFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnInFileClick(TObject *Sender)
{
	char *p,str[256];
	OpenDialog->Title="Input Receiver Log File";
	OpenDialog->FileName="";
	if (!OpenDialog->Execute()) return;
	InFile->Text=OpenDialog->FileName;
	strcpy(str,InFile->Text.c_str());
	if (!(p=strrchr(str,'.'))) p=str+strlen(p);
	strcpy(p,".obs"); OutFile1->Text=str;
	strcpy(p,".nav"); OutFile2->Text=str;
	strcpy(p,".sbs"); OutFile3->Text=str;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFile1Click(TObject *Sender)
{
	OpenDialog2->Title="Output RINEX OBS File";
	OpenDialog2->FileName="";
	if (!OpenDialog2->Execute()) return;
	OutFile1->Text=OpenDialog2->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFile2Click(TObject *Sender)
{
	OpenDialog2->Title="Output RINEX NAV File";
	OpenDialog2->FileName="";
	if (!OpenDialog2->Execute()) return;
	OutFile2->Text=OpenDialog2->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFile3Click(TObject *Sender)
{
	OpenDialog2->Title="Output SBAS Log File";
	OpenDialog2->FileName="";
	if (!OpenDialog2->Execute()) return;
	OutFile3->Text=OpenDialog2->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::UpdateEnable(void)
{
	TimeY1->Enabled=TimeStartF->Checked;
	TimeH1->Enabled=TimeStartF->Checked;
	TimeY1UD->Enabled=TimeStartF->Checked;
	TimeH1UD->Enabled=TimeStartF->Checked;
	TimeY2->Enabled=TimeEndF->Checked;
	TimeH2->Enabled=TimeEndF->Checked;
	TimeY2UD->Enabled=TimeEndF->Checked;
	TimeH2UD->Enabled=TimeEndF->Checked;
	TimeInt->Enabled=TimeIntF->Checked;
	OutFile1->Enabled=OutFileEna1->Checked;
	OutFile2->Enabled=OutFileEna2->Checked;
	OutFile3->Enabled=OutFileEna3->Checked;
	BtnOutFile1->Enabled=OutFileEna1->Checked;
	BtnOutFile2->Enabled=OutFileEna2->Checked;
	BtnOutFile3->Enabled=OutFileEna3->Checked;
	BtnOutFileView1->Enabled=OutFileEna1->Checked;
	BtnOutFileView2->Enabled=OutFileEna2->Checked;
	BtnOutFileView3->Enabled=OutFileEna3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::OutFileEna1Click(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeStartFClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeEndFClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeIntFClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeY1UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double ep[]={2000,1,1,0,0,0};
	int p=TimeY1->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
	if (4<p&&p<8) {
	    ep[1]+=ud;
	    if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
	    else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
	}
	else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
	time2epoch(epoch2time(ep),ep);
	TimeY1->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
	TimeY1->SelStart=p>7||p==0?10:(p>4?7:4);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeH1UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int hms[3]={0},sec,p=TimeH1->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeH1->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
	if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
	sec=hms[0]*3600+hms[1]*60+hms[2];
	if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
	TimeH1->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
	TimeH1->SelStart=p>5||p==0?8:(p>2?5:2);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeY2UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double ep[]={2000,1,1,0,0,0};
	int p=TimeY2->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
	if (4<p&&p<8) {
	    ep[1]+=ud;
	    if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
	    else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
	}
	else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
	time2epoch(epoch2time(ep),ep);
	TimeY2->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
	TimeY2->SelStart=p>7||p==0?10:(p>4?7:4);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::TimeH2UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int hms[3]={0},sec,p=TimeH2->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeH2->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
	if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
	sec=hms[0]*3600+hms[1]*60+hms[2];
	if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
	TimeH2->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
	TimeH2->SelStart=p>5||p==0?8:(p>2?5:2);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOptionsClick(TObject *Sender)
{
	if (OptDlg->ShowModal()!=mrOk) return;	
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFileView1Click(TObject *Sender)
{
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(OutFile1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFileView2Click(TObject *Sender)
{
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(OutFile2->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::BtnOutFileView3Click(TObject *Sender)
{
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(OutFile3->Text);
}
//---------------------------------------------------------------------------


