//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "plotmain.h"
#include "plotopt.h"
#include "refdlg.h"
#include "rtklib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPlotOptDialog *PlotOptDialog;
//---------------------------------------------------------------------------
__fastcall TPlotOptDialog::TPlotOptDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::FormShow(TObject *Sender)
{
	char s1[64],s2[64];
	AnsiString s;
	TimeStart->Checked=Plot->TimeStart;
	TimeEnd->Checked=Plot->TimeEnd;
	TimeY1->Text=Plot->TimeY1;
	TimeH1->Text=Plot->TimeH1;
	TimeY2->Text=Plot->TimeY2;
	TimeH2->Text=Plot->TimeH2;
	TimeIntF->Checked=Plot->TimeIntF;
	TimeInt->Text=s.sprintf("%.2f",Plot->TimeInt);
	ObsFormat->ItemIndex=Plot->ObsFormat;
	TimeLabel->ItemIndex=Plot->TimeLabel;
	AutoScale->ItemIndex=Plot->AutoScale;
	ShowStats->ItemIndex=Plot->ShowStats;
	ShowArrow->ItemIndex=Plot->ShowArrow;
	ShowSlip ->ItemIndex=Plot->ShowSlip;
	ShowErr  ->ItemIndex=Plot->ShowErr;
	ShowEph  ->ItemIndex=Plot->ShowEph;
	EnaSbas  ->ItemIndex=Plot->EnaSbas;
	PlotStyle->ItemIndex=Plot->PlotStyle;
	int marks[]={1,2,3,4,5,10,15,20};
	for (int i=0;i<8;i++) {
		if (marks[i]==Plot->MarkSize) MarkSize->ItemIndex=i;
	}
	MColor1->Color=Plot->MColor[1];
	MColor2->Color=Plot->MColor[2];
	MColor3->Color=Plot->MColor[3];
	MColor4->Color=Plot->MColor[4];
	MColor5->Color=Plot->MColor[5];
	Color1->Color=Plot->CColor[0];
	Color2->Color=Plot->CColor[1];
	Color3->Color=Plot->CColor[2];
	Color4->Color=Plot->CColor[3];
	FontLabel->Font->Assign(Plot->Font);
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
	ElMask->Text=s.sprintf("%.0f",Plot->ElMask);
	YRange->Text=s.sprintf("%.2f",Plot->YRange);
	Origin->ItemIndex=Plot->Origin;
	RefPos1->Text=s.sprintf("%.9f",Plot->OOPos[0]*R2D);
	RefPos2->Text=s.sprintf("%.9f",Plot->OOPos[1]*R2D);
	RefPos3->Text=s.sprintf("%.4f",Plot->OOPos[2]);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnOKClick(TObject *Sender)
{
	Plot->TimeStart=TimeStart->Checked;
	Plot->TimeEnd=TimeEnd->Checked;
	Plot->TimeY1=TimeY1->Text;
	Plot->TimeH1=TimeH1->Text;
	Plot->TimeY2=TimeY2->Text;
	Plot->TimeH2=TimeH2->Text;
	Plot->TimeIntF=TimeIntF->Checked;
	Plot->TimeInt=TimeInt->Text.ToDouble();
	Plot->ObsFormat=ObsFormat->ItemIndex;
	Plot->TimeLabel=TimeLabel->ItemIndex;
	Plot->AutoScale=AutoScale->ItemIndex;
	Plot->ShowStats=ShowStats->ItemIndex;
	Plot->ShowArrow=ShowArrow->ItemIndex;
	Plot->ShowSlip=ShowSlip->ItemIndex;
	Plot->ShowErr=ShowErr->ItemIndex;
	Plot->ShowEph=ShowEph->ItemIndex;
	Plot->EnaSbas=EnaSbas->ItemIndex;
	Plot->PlotStyle=PlotStyle->ItemIndex;
	int marks[]={1,2,3,4,5,10,15,20};
	Plot->MarkSize=marks[MarkSize->ItemIndex];
	Plot->MColor[1]=MColor1->Color;
	Plot->MColor[2]=MColor2->Color;
	Plot->MColor[3]=MColor3->Color;
	Plot->MColor[4]=MColor4->Color;
	Plot->MColor[5]=MColor5->Color;
	Plot->CColor[0]=Color1->Color;
	Plot->CColor[1]=Color2->Color;
	Plot->CColor[2]=Color3->Color;
	Plot->CColor[3]=Color4->Color;
	Plot->Font->Assign(FontLabel->Font);
	Plot->ElMask=ElMask->Text.ToDouble();
	Plot->YRange=YRange->Text.ToDouble();
	Plot->Origin=Origin->ItemIndex;
	Plot->OOPos[0]=RefPos1->Text.ToDouble()*D2R;
	Plot->OOPos[1]=RefPos2->Text.ToDouble()*D2R;
	Plot->OOPos[2]=RefPos3->Text.ToDouble();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::MColorClick(TObject *Sender)
{
	TPanel *panel=(TPanel *)Sender;
	ColorDialog->Color=panel->Color;
	if (!ColorDialog->Execute()) return;
	panel->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor1Click(TObject *Sender)
{
	ColorDialog->Color=Color1->Color;
	if (!ColorDialog->Execute()) return;
	Color1->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor2Click(TObject *Sender)
{
	ColorDialog->Color=Color2->Color;
	if (!ColorDialog->Execute()) return;
	Color2->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor3Click(TObject *Sender)
{
	ColorDialog->Color=Color3->Color;
	if (!ColorDialog->Execute()) return;
	Color3->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor4Click(TObject *Sender)
{
	ColorDialog->Color=Color4->Color;
	if (!ColorDialog->Execute()) return;
	Color4->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnFontClick(TObject *Sender)
{
	AnsiString s;
	FontDialog->Font=FontLabel->Font;
	if (!FontDialog->Execute()) return;
	FontLabel->Font=FontDialog->Font;
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnRefPosClick(TObject *Sender)
{
	AnsiString s;
	RefDialog->RovPos[0]=RefPos1->Text.ToDouble();
	RefDialog->RovPos[1]=RefPos2->Text.ToDouble();
	RefDialog->RovPos[2]=RefPos3->Text.ToDouble();
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	RefDialog->BtnLoad->Enabled=true;
	if (RefDialog->ShowModal()!=mrOk) return;
	RefPos1->Text=s.sprintf("%.9f",RefDialog->Pos[0]);
	RefPos2->Text=s.sprintf("%.9f",RefDialog->Pos[1]);
	RefPos3->Text=s.sprintf("%.4f",RefDialog->Pos[2]);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeStartClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::AutoScaleChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::OriginChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeIntFClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::UpdateEnable(void)
{
	TimeY1->Enabled=TimeStart->Checked;
	TimeH1->Enabled=TimeStart->Checked;
	TimeY2->Enabled=TimeEnd->Checked;
	TimeH2->Enabled=TimeEnd->Checked;
	TimeY1UD->Enabled=TimeStart->Checked;
	TimeH1UD->Enabled=TimeStart->Checked;
	TimeY2UD->Enabled=TimeEnd->Checked;
	TimeH2UD->Enabled=TimeEnd->Checked;
	TimeInt->Enabled=TimeIntF->Checked;
	RefPos1->Enabled=Origin->ItemIndex==4&&Plot->Obs.n==0;
	RefPos2->Enabled=Origin->ItemIndex==4&&Plot->Obs.n==0;
	RefPos3->Enabled=Origin->ItemIndex==4&&Plot->Obs.n==0;
	BtnRefPos->Enabled=Origin->ItemIndex==4&&Plot->Obs.n==0;
	ShowErr->Enabled=Plot->Obs.n==0;
	ShowArrow->Enabled=Plot->Obs.n==0;
	ShowSlip->Enabled=Plot->Obs.n>0;
	ShowEph->Enabled=Plot->Obs.n>0;
	EnaSbas->Enabled=Plot->Obs.n>0;
	ElMask->Enabled=Plot->Obs.n>0;
	AutoScale->Enabled=Plot->Obs.n==0;
	YRange->Enabled=Plot->Obs.n==0;
	Origin->Enabled=Plot->Obs.n==0;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeY1UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double ep[]={2000,1,1,0,0,0};
	int p=TimeY1->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
	if (4<p&&p<8) {
	    ep[1]+=ud;
	    if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
	    else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
	}
	else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
	time2epoch(epoch2time(ep),ep);
	TimeY1->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
	TimeY1->SelStart=p>7||p==0?10:(p>4?7:4);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeH1UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int hms[3]={0},sec,p=TimeH1->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeH1->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
	if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
	sec=hms[0]*3600+hms[1]*60+hms[2];
	if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
	TimeH1->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
	TimeH1->SelStart=p>5||p==0?8:(p>2?5:2);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeY2UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double ep[]={2000,1,1,0,0,0};
	int p=TimeY2->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
	if (4<p&&p<8) {
	    ep[1]+=ud;
	    if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
	    else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
	}
	else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
	time2epoch(epoch2time(ep),ep);
	TimeY2->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
	TimeY2->SelStart=p>7||p==0?10:(p>4?7:4);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::TimeH2UDChangingEx(TObject *Sender,
      bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int hms[3]={0},sec,p=TimeH2->SelStart,ud=Direction==updUp?1:-1;
	sscanf(TimeH2->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
	if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
	sec=hms[0]*3600+hms[1]*60+hms[2];
	if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
	TimeH2->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
	TimeH2->SelStart=p>5||p==0?8:(p>2?5:2);
}
//---------------------------------------------------------------------------
