/*------------------------------------------------------------------------------
* crescent.h : hemisphere crescent receiver dependent functions
*
*          Copyright (C) 2007 by T.TAKASU, All rights reserved.
*
* version : $Revision: 1.2 $ $Date: 2008/07/14 00:05:05 $
* history : 2008/05/21 1.0 new
*-----------------------------------------------------------------------------*/
#ifndef CRESCENT_H
#define CRESCENT_H
#include "rtklib.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int decodecres(const unsigned char *buff, int len, gtime_t ts, gtime_t te,
                      double tint, int opt, obs_t *obs, nav_t *nav,
                      sbsmsg_t *sbsmsg, int *sat);
extern void convcres(FILE *fp, FILE *ofp, FILE *nfp, FILE *sfp, gtime_t ts,
                     gtime_t te, double tint, const rnxopt_t *rnxopt, int opt);
extern void readcres(FILE *fp, gtime_t ts, gtime_t te, double tint, int opt,
                     obs_t *obs, nav_t *nav, sbs_t *sbs, int *nmax);

#ifdef __cplusplus
}
#endif
#endif /* CRESCENT_H */
